"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));

var _prismjs = _interopRequireDefault(require("prismjs"));

require("prismjs/components/prism-css");

require("prismjs/components/prism-diff");

require("prismjs/components/prism-javascript");

require("prismjs/components/prism-json");

require("prismjs/components/prism-jsx");

require("prismjs/components/prism-markup");

require("prismjs/components/prism-tsx");

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

var syntaxColorer = function syntaxColorer(code, language) {
  var prismLanguage;

  switch (language) {
    case "ts":
      prismLanguage = _prismjs["default"].languages.tsx;
      break;

    case "js":
    case "sh":
      prismLanguage = _prismjs["default"].languages.jsx;
      break;

    case "diff":
      prismLanguage = (0, _objectSpread2["default"])({}, _prismjs["default"].languages.diff); // original `/^[-<].*$/m` matches lines starting with `<` which matches
      // <SomeComponent />
      // we will only use `-` as the deleted marker

      prismLanguage.deleted = /^[-].*$/m;
      break;

    default:
      prismLanguage = (0, _getObjectValue["default"])(_prismjs["default"].languages, [language], _prismjs["default"].languages.jsx);
      break;
  }

  if (!prismLanguage) {
    if (language) {
      throw new Error("unsuppored language: \"".concat(language, "\", \"").concat(code, "\""));
    } else {
      prismLanguage = _prismjs["default"].languages.jsx;
    }
  }

  return _prismjs["default"].highlight(code, prismLanguage);
};

var _default = syntaxColorer;
exports["default"] = _default;
module.exports = exports.default;